package org.jenkinsci.plugins.p4_client.connection;

import hudson.Extension;
import hudson.util.FormValidation;

import java.io.IOException;

import javax.servlet.ServletException;

import net.sf.json.JSONObject;

import org.kohsuke.stapler.DataBoundConstructor;
import org.kohsuke.stapler.QueryParameter;
import org.kohsuke.stapler.StaplerRequest;
import org.kohsuke.stapler.StaplerResponse;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class PasswordConnection extends ConnectionProvider {

	private Logger logger = LoggerFactory.getLogger(ConnectionProvider.class);

	private String port;
	private String user;

	@DataBoundConstructor
	public PasswordConnection(String port, String user) {
		this.port = port;
		this.user = user;
	}

	public static final DescriptorImpl DESCRIPTOR = new DescriptorImpl();

	@Extension
	public static class DescriptorImpl extends ConnectionDescriptor {

		private static Logger logger = LoggerFactory
				.getLogger(DescriptorImpl.class);

		/**
		 * public no-argument constructor
		 */
		public DescriptorImpl() {
			load();
		}

		public FormValidation doAddConnection() {
			logger.info("[doAddConnection]");
			return FormValidation.ok();
		}
		
		@Override
		public boolean configure(StaplerRequest req, JSONObject json)
				throws FormException {

			logger.info("[Basic save()]");

			save();
			return true;
		}

		@Override
		public String getDisplayName() {
			return "Password Authentication";
		}

		public FormValidation doCheckPort(@QueryParameter final String value) {
			return FormValidation.error("TODO doCheckPort");
		}

		public FormValidation doCheckUser(@QueryParameter final String value) {
			return FormValidation.error("TODO doCheckUser");
		}
	}

}
